%global install_loc         %{_datadir}/eclipse/dropins
# Taken from update site so we match upstream
#  http://download.eclipse.org/mylyn/archive/3.6.0/v20110608-1400/
%global qualifier           v20120319-0200
%global tag 3_7_0

Name: eclipse-mylyn-commons
Summary: Common libraries for Eclipse Mylyn
Version: 3.7.0
Release: 12%{?dist}
License: EPL and ASL 2.0
URL: http://www.eclipse.org/mylyn

%if 0%{?rhel} >= 6
ExclusiveArch: %{ix86} x86_64
%else
BuildArch: noarch
%endif


Source0: http://git.eclipse.org/c/mylyn/org.eclipse.mylyn.commons.git/snapshot/R_%{tag}.tar.bz2

# org.eclipse.mylyn.context.core extracted from 
# http://git.eclipse.org/c/mylyn/org.eclipse.mylyn.context.git/snapshot/R_3_7_0.tar.bz2
Source1: org.eclipse.mylyn.context.core.tar.bz2

#fetchCompatibility.sh
Source2: org.eclipse.core.runtime.compatibility.auth.tar.bz2

# Not sure if this would be suitable for upstream?
# It changes the Bundle-Require header to
# Import-Package
Patch0: %{name}-xmlrpc-import-package-manifest-fix.patch
Patch1: %{name}-main-feature-fix.patch

# Those patches fix the layout issues. Mylyn uses nested features, and in some places
# nested feature requires one of parent issues which cannot be found when building nested
# feature.
Patch2: %{name}-netimport.patch
Patch3: %{name}-coreimport.patch
Patch4: %{name}-httpimport.patch

# Imports must match available apache version.
Patch5: %{name}-fix-apache-import-version.patch


Patch6: %{name}-fix-identity-ui.patch
BuildRequires: java-devel >= 1.7.0
BuildRequires: jpackage-utils
BuildRequires: eclipse-pde >= 1:4.2.0
BuildRequires: apache-commons-lang >= 2.6-6
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-io >= 2.3
BuildRequires: ws-commons-util >= 1.0.1-21
BuildRequires: xmlrpc3-client >= 3.1.3-8
BuildRequires: xmlrpc3-common >= 3.1.3-8
BuildRequires: ws-jaxme >= 0.5.1-2.4
BuildRequires: jdom >= 1.1.2-3
BuildRequires: rome >= 0.9-9
BuildRequires: httpcomponents-client >= 4.1.3-2
BuildRequires: httpcomponents-core >= 4.1.4
BuildRequires: apache-commons-discovery >= 0.5-2
# The following is required for javax.xml.stream (apparently openjdk ships it too)
# not sure what's best here.
BuildRequires: xml-commons-apis
Requires: eclipse-platform >= 1:4.2.0
Requires: apache-commons-lang >= 2.6-6
Requires: apache-commons-logging
Requires: apache-commons-io >= 2.3
Requires: ws-commons-util >= 1.0.1-21
Requires: xmlrpc3-client  >= 3.1.3-8
Requires: xmlrpc3-common  >= 3.1.3-8
Requires: ws-jaxme >= 0.5.1-2.4
Requires: jpackage-utils
Requires: rome >= 0.9-9
Requires: xml-commons-apis
Requires: httpcomponents-client >= 4.1.3-2
Requires: httpcomponents-core >= 4.1.4
Requires: apache-commons-discovery >= 0.5-2
Requires: jdom >= 1.1.2-3

Group: Development/Tools

%description
Mylyn integrates task support into Eclipse.  It supports offline editing
for certain task repositories and monitors work activity to hide
information that is not relevant to the current task. This package includes
common libraries used by other Eclipse Mylyn packages.

%prep
%setup -q -n R_%{tag}
%setup -q -T -D -a 1 -n R_%{tag}
%setup -q -T -D -a 2 -n R_%{tag}

rm -rf orbitDeps
mkdir orbitDeps
pushd orbitDeps
ln -s %{_javadir}/apache-commons-lang.jar
ln -s %{_javadir}/httpcomponents/httpcore.jar
ln -s %{_javadir}/httpcomponents/httpclient.jar 
ln -s %{_javadir}/apache-commons-io.jar
ln -s %{_javadir}/apache-commons-logging-api.jar
ln -s %{_javadir}/apache-commons-discovery.jar
ln -s %{_javadir}/xmlrpc3-client.jar
ln -s %{_javadir}/xmlrpc3-common.jar
ln -s %{_javadir}/ws-commons-util.jar
ln -s %{_javadir}/jdom.jar
ln -s %{_javadir}/jaxme/jaxmeapi.jar
ln -s %{_javadir}/rome*.jar
ln -s %{_javadir}/jaxp.jar
ln -s %{_javadir}/google-gson.jar
popd

ls -1 | grep  'org.eclipse.mylyn.*.tests' | xargs rm -rf

%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6

%build

eclipse-pdebuild -f org.eclipse.mylyn.commons \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.commons.identity \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.commons.sdk \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier} -DindividualSourceBundles=true" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.commons.activity \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.commons.compatibility \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps


eclipse-pdebuild -f org.eclipse.mylyn.discovery \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.commons.notifications \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.commons.repositories \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.commons.repositories.http \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

eclipse-pdebuild -f org.eclipse.mylyn.monitor \
 -a "-DjavacSource=1.5 -DjavacTarget=1.5 -DforceContextQualifier=%{qualifier} -DmylynQualifier=%{qualifier}" \
 -o `pwd`/orbitDeps

%install
install -d -m 755 %{buildroot}%{_datadir}/eclipse
install -d -m 755 %{buildroot}%{install_loc}/mylyn-commons

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.activity.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.compatibility.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.compatibility.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.identity.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.notifications.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.repositories.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.repositories.http.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.commons.sdk.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.discovery.zip

unzip -q -o -d %{buildroot}%{install_loc}/mylyn-commons \
 build/rpmBuild/org.eclipse.mylyn.monitor.zip

pushd %{buildroot}%{install_loc}/mylyn-commons/eclipse/plugins
rm -rf org.jdom_*.jar
rm -rf org.apache.xmlrpc_*.jar
rm -rf json.jar
rm -rf javax.xml_*.jar
rm -rf javax.xml.bind_*.jar
rm -rf org.apache.commons.codec_*.jar
rm -rf org.apache.commons.httpclient_*.jar
rm -rf org.apache.commons.io_*.jar
rm -rf org.apache.commons.lang_*.jar
rm -rf org.apache.commons.logging_*.jar
rm -rf org.apache.httpcomponents.httpclient_*.jar
rm -rf org.apache.httpcomponents.httpcore_*.jar
rm -rf org.apache.ws.commons.util_*.jar
rm -rf com.sun.syndication_*.jar
rm -rf rome*.jar

ln -s %{_javadir}/apache-commons-lang.jar
ln -s %{_javadir}/apache-commons-io.jar
ln -s %{_javadir}/apache-commons-logging-api.jar
ln -s %{_javadir}/apache-commons-discovery.jar
ln -s %{_javadir}/httpcomponents/httpcore.jar
ln -s %{_javadir}/httpcomponents/httpclient.jar 
ln -s %{_javadir}/commons-httpclient.jar 
ln -s %{_javadir}/xmlrpc3-client.jar
ln -s %{_javadir}/xmlrpc3-common.jar
ln -s %{_javadir}/ws-commons-util.jar
ln -s %{_javadir}/jdom.jar
ln -s %{_javadir}/jaxme/jaxmeapi.jar
ln -s %{_javadir}/rome*.jar
ln -s %{_javadir}/jaxp.jar
#I am not sure if this is required here as it was not required for build.
#ln -s %{_javadir}/json.jar
ln -s %{_javadir}/json-lib.jar
popd

%files
%{install_loc}/mylyn-commons
%doc org.eclipse.mylyn.commons-feature/epl-v10.html
%doc org.eclipse.mylyn.commons-feature/license.html

%changelog
* Wed May 2 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-12
- Build source bundles.
- Update minimum dependency to commons-io.

* Thu Apr 19 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-10
- Bug 812791 - Bundles several libraries

* Thu Apr 12 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-8
- Rebuild with Eclipse 4.2
- Bundle compatibility auth plugin.

* Thu Apr 12 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-7
- Set minimum requires on apache-commons-discovery.
- Use eclipse-pdebuild

* Tue Mar 27 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-6
- Importing proper client version.

* Mon Mar 26 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-5
- Restored ExclusiveArch for RHEL.

* Mon Mar 26 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-4
- Build all features.

* Mon Mar 26 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-3
- Specify minimum eclipse-pde requirement.

* Mon Mar 26 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-2
- Build main commons feature.

* Fri Mar 23 2012 Krzysztof Daniel <kdaniel@redhat.com> 3.7.0-1
- Update to upstream 3.7.0 release.

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.6.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu Dec 15 2011 Sami Wagiaalla <swagiaal@redhat.com> 3.6.4-4
- Remove unconditional noarch.

* Fri Dec 2 2011 Sami Wagiaalla <swagiaal@redhat.com> 3.6.4-2
- Set noarch conditionally. 

* Wed Nov 30 2011 Sami Wagiaalla <swagiaal@redhat.com> 3.6.4-2
- Add ExclusiveArch: %{ix86} x86_64 for RHEL.

* Mon Nov 28 2011 Andrew Robinson <arobinso@redhat.com> 3.6.4-1
- Update to upstream 3.6.4 release.

* Fri Oct 28 2011 Andrew Robinson <arobinso@redhat.com> 3.6.3-1
- Update to upstream 3.6.3 release.

* Fri Oct 7 2011 Alexander Kurtakov <akurtako@redhat.com> 3.6.2-1
- Update to upstream 3.6.2 release.

* Thu Jul 14 2011 Severin Gehwolf <sgehwolf@redhat.com> 3.6.0-3
- Mylyn requires Eclipse 3.5 and up. Changed R/BRs
  accordingly.

* Wed Jul 13 2011 Severin Gehwolf <sgehwolf@redhat.com> 3.6.0-2
- Use source download link over custom source fetch script.

* Wed Jul 13 2011 Severin Gehwolf <sgehwolf@redhat.com> 3.6.0-1
- Update to upstream 3.6.0 release.

* Tue Apr 26 2011 Severin Gehwolf <sgehwolf@redhat.com> 3.5.1-1
- Update to upstream 3.5.1 release.

* Fri Apr 15 2011 Severin Gehwolf <sgehwolf@redhat.com> 3.5.0-2
- Add patch for org.eclipse.mylyn.commons.xmlrpc to use
  Import-Package header instead of Bundle-Require.

* Wed Apr 13 2011 Severin Gehwolf <sgehwolf@redhat.com> 3.5.0-1
- Introduce eclipse-mylyn-commons, since eclipse-mylyn will be
  broken up into several source RPMs starting with Mylyn 3.5.0
  release.
